Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 6772)
@@ -17,6 +17,4 @@
    
    PUBLIC crs_dom_alloc  ! Called from crsini.F90
-   PUBLIC crs_dom_alloc1  ! Called from crsini.F90
-   PUBLIC crs_dom_alloc2  ! Called from crsini.F90
    PUBLIC dom_grid_glo   
    PUBLIC dom_grid_crs 
@@ -104,6 +102,17 @@
       REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: e1v_crs, e2v_crs ! horizontal scale factors grid type V
       REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: e1f_crs, e2f_crs ! horizontal scale factors grid type F
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_crs, e3u_crs, e3v_crs, e3f_crs, e3w_crs
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_max_crs, e3u_max_crs, e3v_max_crs, e3f_max_crs, e3w_max_crs
+
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE :: ht_0_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_0_crs, e3u_0_crs, e3v_0_crs, e3f_0_crs, e3w_0_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_max_0_crs, e3u_max_0_crs, e3v_max_0_crs, e3f_max_0_crs, e3w_max_0_crs
+
+#if defined key_vvl
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_b_crs, e3u_b_crs, e3v_b_crs, e3f_b_crs, e3w_b_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_n_crs, e3u_n_crs, e3v_n_crs, e3f_n_crs, e3w_n_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_a_crs, e3u_a_crs, e3v_a_crs, e3f_a_crs, e3w_a_crs
+
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: e3t_max_n_crs, e3u_max_n_crs, e3v_max_n_crs, e3f_max_n_crs, e3w_max_n_crs
+#endif
+
       
       ! Surface
@@ -116,5 +125,9 @@
       REAL(wp), DIMENSION(:,:),   ALLOCATABLE,SAVE :: ff_crs
       INTEGER,  DIMENSION(:,:),   ALLOCATABLE,SAVE :: mbathy_crs, mbkt_crs, mbku_crs, mbkv_crs
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE,SAVE :: gdept_crs, gdepu_crs, gdepv_crs, gdepw_crs
+
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE,SAVE :: gdept_0_crs, gdepu_0_crs, gdepv_0_crs, gdepw_0_crs
+#if defined key_vvl
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE,SAVE :: gdept_n_crs, gdepu_n_crs, gdepv_n_crs, gdepw_n_crs
+#endif
 
       ! Weights
@@ -146,6 +159,9 @@
       REAL(wp)     ::  rfactxy 
 
+      INTEGER, DIMENSION(:)    , ALLOCATABLE      :: nfactx,nfacty
+
+
       ! Physical and dynamical ocean fields for output or passing to TOP, time-mean fields
-      REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE      :: tsb_crs,tsn_crs,rab_crs_n
+      REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE      :: tsb_crs,tsn_crs,tsa_crs,rab_crs_n
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: un_crs, vn_crs, wn_crs, rke_crs
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: ub_crs, vb_crs
@@ -161,5 +177,7 @@
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: fmmflx_crs
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: utau_crs, vtau_crs, taum_crs
-      REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: rnf_crs
+      REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: rnf_crs,rnf_b_crs
+      REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE :: trc_i_crs,trc_o_crs
+      REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE :: sbc_trc_crs, sbc_trc_b_crs
 
       REAL(wp), PUBLIC, DIMENSION(:,:,:) , ALLOCATABLE ::   uslp_crs, wslpi_crs          !: i_slope at U- and W-points
@@ -195,5 +213,5 @@
 CONTAINS
    
-   INTEGER FUNCTION crs_dom_alloc1()
+   INTEGER FUNCTION crs_dom_alloc()
       !!-------------------------------------------------------------------
       !!                     *** FUNCTION crs_dom_alloc ***
@@ -210,6 +228,13 @@
        &       mi0_crs (jpiglo_crs), mi1_crs (jpiglo_crs),  &
        &       mj0_crs (jpjglo_crs), mj1_crs (jpjglo_crs),  &
-       &       mig_crs (jpi_crs)   , mjg_crs (jpj_crs)   ,  STAT=ierr(1) ) 
-
+       &       mig_crs (jpi_crs)   , mjg_crs (jpj_crs)   ,  & 
+       &       mis_crs (jpi_crs)   , mie_crs (jpi_crs)   ,  &
+       &       mjs_crs (jpj_crs)   , mje_crs (jpj_crs)   ,  &
+       &       nfactx  (jpi_crs)   , nfacty  (jpj_crs)   ,  &
+       &       nimppt_crs(jpnij) , nlcit_crs(jpnij) , nldit_crs(jpnij) , nleit_crs(jpnij) , &
+       &       nimppt_full(jpnij), nlcit_full(jpnij), nldit_full(jpnij), nleit_full(jpnij), &
+       &       njmppt_crs(jpnij) , nlcjt_crs(jpnij) , nldjt_crs(jpnij) , nlejt_crs(jpnij) , &
+       &       njmppt_full(jpnij), nlcjt_full(jpnij), nldjt_full(jpnij), nlejt_full(jpnij), &
+       &       nfiimpp_full(jpni,jpnj) , nfiimpp_crs(jpni,jpnj) , STAT=ierr(1) ) 
 
       ! Set up Mask and Mesh
@@ -232,12 +257,26 @@
          &      e1e2t_crs(jpi_crs,jpj_crs), STAT=ierr(5))
 
-      ALLOCATE( e3t_crs(jpi_crs,jpj_crs,jpk)    , e3w_crs(jpi_crs,jpj_crs,jpk)    , & 
-         &      e3u_crs(jpi_crs,jpj_crs,jpk)    , e3v_crs(jpi_crs,jpj_crs,jpk)    , &
-         &      e3f_crs(jpi_crs,jpj_crs,jpk)    , e1e2w_msk(jpi_crs,jpj_crs,jpk)  , & 
+      ALLOCATE( e3t_0_crs(jpi_crs,jpj_crs,jpk)    , e3w_0_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3u_0_crs(jpi_crs,jpj_crs,jpk)    , e3v_0_crs(jpi_crs,jpj_crs,jpk)    , &
+         &           ht_0_crs(jpi_crs,jpj_crs),                                     &
+#if defined key_vvl
+         &      e3t_b_crs(jpi_crs,jpj_crs,jpk)    , e3w_b_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3u_b_crs(jpi_crs,jpj_crs,jpk)    , e3v_b_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3t_n_crs(jpi_crs,jpj_crs,jpk)    , e3w_n_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3u_n_crs(jpi_crs,jpj_crs,jpk)    , e3v_n_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3t_a_crs(jpi_crs,jpj_crs,jpk)    , e3w_a_crs(jpi_crs,jpj_crs,jpk)    , &
+         &      e3u_a_crs(jpi_crs,jpj_crs,jpk)    , e3v_a_crs(jpi_crs,jpj_crs,jpk)    , &
+#endif
+         &      e1e2w_msk(jpi_crs,jpj_crs,jpk)  , &
          &      e2e3u_msk(jpi_crs,jpj_crs,jpk)  , e1e3v_msk(jpi_crs,jpj_crs,jpk)  , &
          &      e1e2w_crs(jpi_crs,jpj_crs,jpk)  , e2e3u_crs(jpi_crs,jpj_crs,jpk)  , &
-         &      e1e3v_crs(jpi_crs,jpj_crs,jpk)  , e3t_max_crs(jpi_crs,jpj_crs,jpk), &
-         &      e3w_max_crs(jpi_crs,jpj_crs,jpk), e3u_max_crs(jpi_crs,jpj_crs,jpk), &
-         &      e3v_max_crs(jpi_crs,jpj_crs,jpk), STAT=ierr(6))
+         &      e1e3v_crs(jpi_crs,jpj_crs,jpk)  , &
+         &      e3t_max_0_crs(jpi_crs,jpj_crs,jpk), e3w_max_0_crs(jpi_crs,jpj_crs,jpk) , &
+         &      e3u_max_0_crs(jpi_crs,jpj_crs,jpk), e3v_max_0_crs(jpi_crs,jpj_crs,jpk) , &
+#if defined key_vvl
+         &      e3t_max_n_crs(jpi_crs,jpj_crs,jpk), e3w_max_n_crs(jpi_crs,jpj_crs,jpk) , &
+         &      e3u_max_n_crs(jpi_crs,jpj_crs,jpk), e3v_max_n_crs(jpi_crs,jpj_crs,jpk) , &
+#endif
+         &      STAT=ierr(6))
 
 
@@ -255,6 +294,11 @@
          &      mbku_crs(jpi_crs,jpj_crs)  , mbkv_crs(jpi_crs,jpj_crs) , STAT=ierr(9))
 
-      ALLOCATE( gdept_crs(jpi_crs,jpj_crs,jpk), gdepu_crs(jpi_crs,jpj_crs,jpk) , &
-         &      gdepv_crs(jpi_crs,jpj_crs,jpk), gdepw_crs(jpi_crs,jpj_crs,jpk) , STAT=ierr(10) )
+      ALLOCATE( gdept_0_crs(jpi_crs,jpj_crs,jpk), gdepu_0_crs(jpi_crs,jpj_crs,jpk) , &
+         &      gdepv_0_crs(jpi_crs,jpj_crs,jpk), gdepw_0_crs(jpi_crs,jpj_crs,jpk) , &
+#if defined key_vvl
+         &      gdept_n_crs(jpi_crs,jpj_crs,jpk), gdepu_n_crs(jpi_crs,jpj_crs,jpk) , &
+         &      gdepv_n_crs(jpi_crs,jpj_crs,jpk), gdepw_n_crs(jpi_crs,jpj_crs,jpk) , &
+#endif
+         & STAT=ierr(10))
 
 
@@ -270,7 +314,10 @@
 
      ALLOCATE( sshb_crs(jpi_crs,jpj_crs), sshn_crs(jpi_crs,jpj_crs),  ssha_crs(jpi_crs,jpj_crs), &
+         &     qsr_crs(jpi_crs ,jpj_crs), wndm_crs(jpi_crs,jpj_crs), utau_crs(jpi_crs,jpj_crs) , &
+         &     vtau_crs(jpi_crs,jpj_crs), taum_crs(jpi_crs,jpj_crs),  &
+         &     rnf_crs (jpi_crs,jpj_crs), rnf_b_crs(jpi_crs ,jpj_crs), &
          &     emp_crs (jpi_crs,jpj_crs), emp_b_crs(jpi_crs,jpj_crs), &
-         &     qsr_crs(jpi_crs ,jpj_crs), wndm_crs(jpi_crs,jpj_crs), utau_crs(jpi_crs,jpj_crs) , &
-         &     vtau_crs(jpi_crs,jpj_crs), taum_crs(jpi_crs,jpj_crs), rnf_crs(jpi_crs ,jpj_crs), &
+         &     sbc_trc_crs (jpi_crs,jpj_crs,jpts), sbc_trc_b_crs(jpi_crs,jpj_crs,jpts), &
+         &     trc_i_crs (jpi_crs,jpj_crs,jpts), trc_o_crs(jpi_crs,jpj_crs,jpts), &
          &     fr_i_crs(jpi_crs,jpj_crs), sfx_crs(jpi_crs ,jpj_crs), fmmflx_crs(jpi_crs ,jpj_crs),  STAT=ierr(12)  )
 
@@ -285,5 +332,5 @@
 #endif
 
-     ALLOCATE( tsn_crs(jpi_crs,jpj_crs,jpk,jpts), tsb_crs(jpi_crs,jpj_crs,jpk,jpts),  &
+     ALLOCATE( tsb_crs(jpi_crs,jpj_crs,jpk,jpts), tsn_crs(jpi_crs,jpj_crs,jpk,jpts), tsa_crs(jpi_crs,jpj_crs,jpk,jpts),  &
                en_crs(jpi_crs,jpj_crs,jpk),   avt_crs(jpi_crs,jpj_crs,jpk),    &
 # if defined key_zdfddm
@@ -295,46 +342,7 @@
          &      hmlp_crs(jpi_crs,jpj_crs) , hmlpt_crs(jpi_crs,jpj_crs) , STAT=ierr(15) )
 
-      crs_dom_alloc1 = MAXVAL(ierr)
-
-   END FUNCTION crs_dom_alloc1
-
-   INTEGER FUNCTION crs_dom_alloc()
-      !!-------------------------------------------------------------------
-      !!                     *** FUNCTION crs_dom_alloc ***
-      !!  ** Purpose :   Allocate public crs arrays  
-      !!-------------------------------------------------------------------
-      !! Local variables
-      INTEGER, DIMENSION(2) :: ierr
-
-      ierr(:) = 0
-         
-      ALLOCATE( nimppt_crs(jpnij) , nlcit_crs(jpnij) , nldit_crs(jpnij) , nleit_crs(jpnij), &
-       &  nimppt_full(jpnij) , nlcit_full(jpnij) , nldit_full(jpnij) , nleit_full(jpnij),   &
-                njmppt_crs(jpnij) , nlcjt_crs(jpnij) , nldjt_crs(jpnij) , nlejt_crs(jpnij), &
-       &  njmppt_full(jpnij) , nlcjt_full(jpnij) , nldjt_full(jpnij) , nlejt_full(jpnij)  , STAT=ierr(1) )
-
-      ALLOCATE( nfiimpp_full(jpni,jpnj) , nfiimpp_crs(jpni,jpnj) ,STAT=ierr(2) )
-
       crs_dom_alloc = MAXVAL(ierr)
 
    END FUNCTION crs_dom_alloc
-   
-   INTEGER FUNCTION crs_dom_alloc2()
-      !!-------------------------------------------------------------------
-      !!                     *** FUNCTION crs_dom_alloc ***
-      !!  ** Purpose :   Allocate public crs arrays  
-      !!-------------------------------------------------------------------
-      !! Local variables
-      INTEGER, DIMENSION(1) :: ierr
-
-      ierr(:) = 0
-      
-      !cbr ALLOCATE( mjs_crs(nlej_crs) , mje_crs(nlej_crs), mis_crs(nlei_crs) , mie_crs(nlei_crs), STAT=ierr(1) )
-      !cbr pk on alloue ac nlej_crs ??????
-      !cbrALLOCATE( mjs_crs(nlcj_crs) , mje_crs(nlcj_crs), mis_crs(nlci_crs) , mie_crs(nlci_crs), STAT=ierr(1) )
-      ALLOCATE( mjs_crs(jpj_crs) , mje_crs(jpj_crs), mis_crs(jpi_crs) , mie_crs(jpi_crs), STAT=ierr(1) )
-      crs_dom_alloc2 = MAXVAL(ierr)
-
-      END FUNCTION crs_dom_alloc2
 
    SUBROUTINE dom_grid_glo
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6772)
@@ -38,5 +38,5 @@
    USE crslbclnk
    USE lib_mpp
-!cbr   USE ieee_arithmetic   
+   USE ieee_arithmetic   
 
    IMPLICIT NONE
@@ -61,129 +61,55 @@
 
    SUBROUTINE crs_dom_msk
+   !!===================================================================
+   !
+   !
+   !
+   !!===================================================================
+   INTEGER  ::  ji, jj, jk                   ! dummy loop indices
+   INTEGER  ::  ijis,ijie,ijjs,ijje
+   REAL(wp) ::  zmask
+   !!-------------------------------------------------------------------
       
-      INTEGER  ::  ji, jj, jk                   ! dummy loop indices
-      INTEGER  ::  ijie,ijis,ijje,ijjs,ij,je_2
-      INTEGER  ::  iji, ijj
-      REAL(wp) ::  zmask
-      INTEGER  :: ir,jr
-      
-      ! Initialize
-      tmask_crs(:,:,:) = 0.0
-      vmask_crs(:,:,:) = 0.0
-      umask_crs(:,:,:) = 0.0
-      fmask_crs(:,:,:) = 0.0
-      !
-      DO jk = 1, jpkm1
-         DO ji = 2, nlei_crs
-            ijie = mie_crs(ji)
-            ijis = mis_crs(ji)
-
-            IF( nldj_crs == 1 .AND. (( mje_crs(2) - mjs_crs(2) ) < 2) )THEN     !!cc bande du sud style ORCA2
-
-               IF( mje_crs(2) - mjs_crs(2) == 1 )THEN
-
-                  jj = mje_crs(2)
-
-                  zmask = 0.0
-                  zmask = SUM( tmask(ijis:ijie,jj,jk) )
-                  IF ( zmask > 0.0 ) tmask_crs(ji,2,jk) = 1.0
-
-                  zmask = 0.0
-                  zmask = SUM( vmask(ijis:ijie,jj     ,jk) )
-                  IF ( zmask > 0.0 ) vmask_crs(ji,2,jk) = 1.0
-
-                  zmask = 0.0
-                  zmask = umask(ijie     ,jj,jk)
-                  IF( zmask > 0.0 )umask_crs(ji,2,jk) = 1.0
-
-                  fmask_crs(ji,jj,jk) = fmask(ijie,2,jk)
-               ENDIF
-            ELSE
-
-               jj   = mje_crs(2)
-               ij   = mjs_crs(2)
-
-               zmask = 0.0
-               zmask = SUM( tmask(ijis:ijie,ij:jj,jk) )
-               IF ( zmask > 0.0 ) tmask_crs(ji,2,jk) = 1.0
-
-               zmask = 0.0
-               zmask = SUM( vmask(ijis:ijie,jj     ,jk) )
-               IF ( zmask > 0.0 ) vmask_crs(ji,2,jk) = 1.0
-
-               zmask = 0.0
-               zmask = SUM(umask(ijie,ij:jj,jk))
-               IF ( zmask > 0.0 ) umask_crs(ji,2,jk) = 1.0
-
-               fmask_crs(ji,jj,jk) = fmask(ijie,2,jk)
-
-            ENDIF
- 
-            DO jj = 3, nlej_crs
-               ijje = mje_crs(jj)
-               ijjs = mjs_crs(jj)
-
-               !iji=117 ; ijj=211
-               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
-               !IF( ji ==iji .AND. jj==ijj .AND. jk==74 )THEN
-               !write(narea+5000,*)"mask ",ji,jj
-               !write(narea+5000,*)"mask ",ijie,ijis,ijjs,ijje
-               !ENDIF
-
-               ir=303-nimpp_crs+1 ; jr=302-njmpp_crs+1
-               IF( ji==ir .AND. jj==jr )THEN
-                   WRITE(narea+2000,*)"mask",ir,jr,ijis+nimpp-1,ijjs+njmpp-1
-               ENDIF
-
-               !IF( ijje .GT. jpj )WRITE(narea+200,*)"BUG",jj,ijjs,ijje,SHAPE(tmask) ; call flush(narea+200)
-               zmask = 0.0
-               zmask = SUM( tmask(ijis:ijie,ijjs:ijje,jk) )
-               IF ( zmask > 0.0 ) tmask_crs(ji,jj,jk) = 1.0
-
-               zmask = 0.0
-               zmask = SUM( vmask(ijis:ijie,ijje     ,jk) )
-               IF ( zmask > 0.0 ) vmask_crs(ji,jj,jk) = 1.0
-
-               zmask = 0.0
-               zmask = SUM( umask(ijie     ,ijjs:ijje,jk) )
-               IF ( zmask > 0.0 ) umask_crs(ji,jj,jk) = 1.0
-
-               fmask_crs(ji,jj,jk) = fmask(ijie,ijje,jk)
-
-            ENDDO
+   ! Initialize
+   tmask_crs(:,:,:) = 0.0
+   vmask_crs(:,:,:) = 0.0
+   umask_crs(:,:,:) = 0.0
+   fmask_crs(:,:,:) = 0.0
+   !
+   DO jk = 1, jpkm1
+      DO ji = nldi_crs, nlei_crs
+
+         ijis = mis_crs(ji)
+         ijie = mie_crs(ji)
+
+         DO jj = nldj_crs, nlej_crs
+
+            ijjs = mjs_crs(jj)
+            ijje = mje_crs(jj)
+
+            zmask = 0.0
+            zmask = SUM( tmask(ijis:ijie,ijjs:ijje,jk) )
+            IF ( zmask > 0.0 ) tmask_crs(ji,jj,jk) = 1.0
+
+            zmask = 0.0
+            zmask = SUM( vmask(ijis:ijie,ijje     ,jk) )
+            IF ( zmask > 0.0 ) vmask_crs(ji,jj,jk) = 1.0
+
+            zmask = 0.0
+            zmask = SUM( umask(ijie     ,ijjs:ijje,jk) )
+            IF ( zmask > 0.0 ) umask_crs(ji,jj,jk) = 1.0
+
+            fmask_crs(ji,jj,jk) = fmask(ijie,ijje,jk)
+
+
          ENDDO
       ENDDO
-      CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
-      !cbr
-      !DO ji=1,jpi_crs-1
-      !DO jj=1,jpj_crs-1
-      !DO jk=1,jpk
-      !   umask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji+1,jj  ,jk)
-      !   vmask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji  ,jj+1,jk)
-      !   fmask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji  ,jj+1,jk) *  tmask_crs(ji+1,jj  ,jk) *   tmask_crs(ji+1,jj+1,jk) 
-      !ENDDO
-      !ENDDO
-      !ENDDO
-      !
-      CALL crs_lbc_lnk( vmask_crs, 'V', 1.0 )
-      CALL crs_lbc_lnk( umask_crs, 'U', 1.0 )
-      CALL crs_lbc_lnk( fmask_crs, 'F', 1.0 )
-      !
-      !cbr
-      !DO ji=2,jpi_crs-1
-      !DO jj=2,jpj_crs-1
-      !DO jk=1,jpk
-      !   IF( tmask(ji-1,jj  ,jk)==1. .AND. tmask(ji  ,jj  ,jk)==1. .AND. umask(ji-1,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK1",ji,jj,jk
-      !   IF( tmask(ji  ,jj  ,jk)==1. .AND. tmask(ji+1,jj  ,jk)==1. .AND. umask(ji  ,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK2",ji,jj,jk
-      !   IF( tmask(ji  ,jj-1,jk)==1. .AND. tmask(ji  ,jj  ,jk)==1. .AND. vmask(ji  ,jj-1,jk)==0. )WRITE(narea+5000,*)"MASK3",ji,jj,jk
-      !   IF( tmask(ji  ,jj  ,jk)==1. .AND. tmask(ji  ,jj+1,jk)==1. .AND. vmask(ji  ,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK4",ji,jj,jk
-      !   IF( umask(ji-1,jj  ,jk)==1. .AND. ( tmask(ji-1,jj  ,jk)==0. .OR. tmask(ji  ,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK5",ji,jj,jk
-      !   IF( umask(ji  ,jj  ,jk)==1. .AND. ( tmask(ji  ,jj  ,jk)==0. .OR. tmask(ji+1,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK6",ji,jj,jk
-      !   IF( vmask(ji  ,jj-1,jk)==1. .AND. ( tmask(ji  ,jj-1,jk)==0. .OR. tmask(ji  ,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK7",ji,jj,jk
-      !   IF( vmask(ji  ,jj  ,jk)==1. .AND. ( tmask(ji  ,jj  ,jk)==0. .OR. tmask(ji  ,jj+1,jk)==0. ) )WRITE(narea+5000,*)"MASK8",ji,jj,jk
-      !ENDDO
-      !ENDDO
-      !ENDDO
-      !
+   ENDDO
+
+   CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
+   CALL crs_lbc_lnk( vmask_crs, 'V', 1.0 )
+   CALL crs_lbc_lnk( umask_crs, 'U', 1.0 )
+   CALL crs_lbc_lnk( fmask_crs, 'F', 1.0 )
+   !
    END SUBROUTINE crs_dom_msk
 
@@ -219,6 +145,9 @@
       !! Local variables
       INTEGER :: ji, jj, jk                   ! dummy loop indices
-      INTEGER :: ijis, ijjs
+      INTEGER :: iji, ijj
       INTEGER  :: ir,jr
+      !!----------------------------------------------------------------
+      p_gphi_crs(:,:)=0._wp
+      p_glam_crs(:,:)=0._wp
 
   
@@ -226,41 +155,37 @@
          CASE ( 'T' )
             DO jj =  nldj_crs, nlej_crs
-               ijjs = mjs_crs(jj) + mybinctr
-               DO ji = 2, nlei_crs
-                  ijis = mis_crs(ji) + mxbinctr 
-                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
-                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
-                  ir=303-nimpp_crs+1 ; jr=302-njmpp_crs+1
-                  WRITE(narea+2000,*)"coordT1",ir,jr
-                  IF( ji==ir .AND. jj==jr )THEN
-                     WRITE(narea+2000,*)"coordT",ir,jr,ijis+nimpp-1,ijjs+njmpp-1
-                  ENDIF
+               ijj = mjs_crs(jj) + 1
+               DO ji = nldi_crs, nlei_crs
+                  iji = mis_crs(ji) + 1
+                  p_gphi_crs(ji,jj) = p_gphi(iji,ijj)
+                  p_glam_crs(ji,jj) = p_glam(iji,ijj)
                ENDDO
             ENDDO
          CASE ( 'U' )
             DO jj =  nldj_crs, nlej_crs
-               ijjs = mjs_crs(jj) + mybinctr                  
-               DO ji = 2, nlei_crs
-                  ijis = mis_crs(ji)
-                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
-                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ijj = mjs_crs(jj) + 1
+               DO ji = nldi_crs, nlei_crs
+                  iji = mie_crs(ji)
+                  p_gphi_crs(ji,jj) = p_gphi(iji,ijj)
+                  p_glam_crs(ji,jj) = p_glam(iji,ijj)
+ 
                ENDDO
             ENDDO
          CASE ( 'V' )
             DO jj =  nldj_crs, nlej_crs
-               ijjs = mjs_crs(jj)
-               DO ji = 2, nlei_crs
-                  ijis = mis_crs(ji) + mxbinctr 
-                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
-                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ijj = mje_crs(jj)
+               DO ji = nldi_crs, nlei_crs
+                  iji = mis_crs(ji) + 1
+                  p_gphi_crs(ji,jj) = p_gphi(iji,ijj)
+                  p_glam_crs(ji,jj) = p_glam(iji,ijj)
                ENDDO
             ENDDO
          CASE ( 'F' )
             DO jj =  nldj_crs, nlej_crs
-               ijjs = mjs_crs(jj)
-               DO ji = 2, nlei_crs
-                  ijis = mis_crs(ji)
-                  p_gphi_crs(ji,jj) = p_gphi(ijis,ijjs)
-                  p_glam_crs(ji,jj) = p_glam(ijis,ijjs)
+               ijj = mje_crs(jj)
+               DO ji = nldi_crs, nlei_crs
+                  iji = mie_crs(ji)
+                  p_gphi_crs(ji,jj) = p_gphi(iji,ijj)
+                  p_glam_crs(ji,jj) = p_glam(iji,ijj)
                ENDDO
             ENDDO
@@ -271,19 +196,19 @@
       CALL crs_lbc_lnk( p_glam_crs, cd_type, 1.0 )
          
-      ! Fill up jrow=1 which is zeroed out or not handled by lbc_lnk and lbc_nfd
-      SELECT CASE ( cd_type )
-         CASE ( 'T', 'V' )
-            DO ji = 2, nlei_crs
-               ijis = mis_crs(ji) + mxbinctr 
-               p_gphi_crs(ji,1) = p_gphi(ijis,1)
-               p_glam_crs(ji,1) = p_glam(ijis,1)
-            ENDDO
-         CASE ( 'U', 'F' )
-            DO ji = 2, nlei_crs
-               ijis = mis_crs(ji) 
-               p_gphi_crs(ji,1) = p_gphi(ijis,1)
-               p_glam_crs(ji,1) = p_glam(ijis,1)
-            ENDDO
-      END SELECT
+!cbr???      ! Fill up jrow=1 which is zeroed out or not handled by lbc_lnk and lbc_nfd
+!      SELECT CASE ( cd_type )
+!         CASE ( 'T', 'V' )
+!            DO ji = 2, nlei_crs
+!               ijis = mis_crs(ji) + mxbinctr 
+!               p_gphi_crs(ji,1) = p_gphi(ijis,1)
+!               p_glam_crs(ji,1) = p_glam(ijis,1)
+!            ENDDO
+!         CASE ( 'U', 'F' )
+!            DO ji = 2, nlei_crs
+!               ijis = mis_crs(ji) 
+!               p_gphi_crs(ji,1) = p_gphi(ijis,1)
+!               p_glam_crs(ji,1) = p_glam(ijis,1)
+!            ENDDO
+!      END SELECT
       !
    END SUBROUTINE crs_dom_coordinates
@@ -317,47 +242,50 @@
       !! Local variables
       INTEGER :: ji, jj, jk     ! dummy loop indices
-      INTEGER :: ijie,ijje,ijrs
+      INTEGER :: ijis,ijie,ijjs,ijje
+      INTEGER :: ji1, jj1
   
       !!----------------------------------------------------------------  
       ! Initialize      
 
-      DO jk = 1, jpk    
-         DO ji = 2, nlei_crs
+         DO ji = nldi_crs, nlei_crs
+
+            ijis = mis_crs(ji)
             ijie = mie_crs(ji)
+
             DO jj = nldj_crs, nlej_crs
-               ijje = mje_crs(jj)   ;   ijrs =  mje_crs(jj) - mjs_crs(jj)
+
+               ijjs = mjs_crs(jj)
+               ijje = mje_crs(jj)
+
                ! Only for a factro 3 coarsening
                SELECT CASE ( cd_type )
                    CASE ( 'T' )
-                      IF( ijrs == 0 .OR. ijrs == 1 ) THEN
-                        ! Si à la frontière sud on a pas assez de maille de la grille mère
-                         p_e1_crs(ji,jj) = p_e1(ijie-1,ijje) * nn_factx
-                         p_e2_crs(ji,jj) = p_e2(ijie-1,ijje) * nn_facty
-                      ELSE
-                         p_e1_crs(ji,jj) = p_e1(ijie-1,ijje-1) * nn_factx
-                         p_e2_crs(ji,jj) = p_e2(ijie-1,ijje-1) * nn_facty
-                      ENDIF
+                      !p_e1_crs(ji,jj) = SUM( p_e1(ijis:ijie     ,ijjs+1       ) )
+                      !p_e2_crs(ji,jj) = SUM( p_e2(ijis+1        ,ijjs:ijje    ) )
+                      p_e1_crs(ji,jj) = REAL(nn_factx,wp)*p_e1(ijis+1,ijjs+1)
+                      p_e2_crs(ji,jj) = REAL(nn_facty,wp)*p_e2(ijis+1,ijjs+1)
                    CASE ( 'U' )
-                      IF( ijrs == 0 .OR. ijrs == 1 ) THEN
-                         ! Si à la frontière sud on a pas assez de maille de la grille mère
-                         p_e1_crs(ji,jj) = p_e1(ijie,ijje) * nn_factx                            
-                         p_e2_crs(ji,jj) = p_e2(ijie,ijje) * nn_facty
-                      ELSE
-                         p_e1_crs(ji,jj) = p_e1(ijie,ijje-1) * nn_factx
-                         p_e2_crs(ji,jj) = p_e2(ijie,ijje-1) * nn_facty
-                      ENDIF
+                      !p_e1_crs(ji,jj) = SUM( p_e1(ijis+1:ijie+1 ,ijjs+1       ) )
+                      !p_e2_crs(ji,jj) = SUM( p_e2(ijie          ,ijjs:ijje    ) )
+                      p_e1_crs(ji,jj) = REAL(nn_factx,wp)*p_e1(ijis+1,ijjs+1       ) 
+                      p_e2_crs(ji,jj) = REAL(nn_facty,wp)*p_e2(ijie  ,ijjs+1       ) 
+
                    CASE ( 'V' )
-                         p_e1_crs(ji,jj) = p_e1(ijie-1,ijje) * nn_factx                            
-                         p_e2_crs(ji,jj) = p_e2(ijie-1,ijje) * nn_facty
+                      !p_e1_crs(ji,jj) = SUM( p_e1(ijis:ijie     ,ijje         ) )
+                      !p_e2_crs(ji,jj) = SUM( p_e2(ijis+1        ,ijjs+1:ijje+1) )
+                      p_e1_crs(ji,jj) = REAL(nn_factx,wp)*p_e1(ijis+1,ijje       ) 
+                      p_e2_crs(ji,jj) = REAL(nn_facty,wp)*p_e2(ijis+1,ijjs+1     ) 
                    CASE ( 'F' )
-                         p_e1_crs(ji,jj) = p_e1(ijie,ijje) * nn_factx                            
-                         p_e2_crs(ji,jj) = p_e2(ijie,ijje) * nn_facty
+                      !p_e1_crs(ji,jj) = SUM( p_e1(ijis+1:ijie+1 ,ijje         ) )
+                      !p_e2_crs(ji,jj) = SUM( p_e2(ijie          ,ijjs+1:ijje+1) )
+                      p_e1_crs(ji,jj) = REAL(nn_factx,wp)*p_e1(ijis+1,ijje       ) 
+                      p_e2_crs(ji,jj) = REAL(nn_facty,wp)*p_e2(ijie  ,ijjs+1     ) 
                END SELECT
             ENDDO
          ENDDO
-      ENDDO
-
-      CALL crs_lbc_lnk( p_e1_crs, cd_type, 1.0, pval=1.0 )
-      CALL crs_lbc_lnk( p_e2_crs, cd_type, 1.0, pval=1.0 )
+
+
+      CALL crs_lbc_lnk( p_e1_crs, cd_type, 1.0 ) !cbr , pval=1.0 )
+      CALL crs_lbc_lnk( p_e2_crs, cd_type, 1.0 ) !cbr , pval=1.0 )
 
    END SUBROUTINE crs_dom_hgr
@@ -416,5 +344,6 @@
       !! Local variables
       REAL(wp)                                :: zdAm
-      INTEGER                                 :: ji, jj, jk , ii, ij, je_2
+      INTEGER                                 :: ji, jj, jk
+      INTEGER :: ijis,ijie,ijjs,ijje
 
       REAL(wp), DIMENSION(:,:,:), POINTER     :: zvol, zmask      
@@ -427,81 +356,22 @@
 
       DO jk = 1, jpk
-         zvol(:,:,jk) =  p_e1(:,:) * p_e2(:,:) * p_e3(:,:,jk) 
+         zvol (:,:,jk) = p_e1(:,:) * p_e2(:,:) * p_e3(:,:,jk) 
+         zmask(:,:,jk) = p_mask(:,:,jk) 
       ENDDO
 
-      zmask(:,:,:) = 0.0
-      !IF( cd_type == 'W' ) THEN
-      !   zmask(:,:,1) = p_mask(:,:,1) 
-      !   DO jk = 2, jpk
-      !      zmask(:,:,jk) = p_mask(:,:,jk-1) 
-      !   ENDDO
-      !ELSE
-         DO jk = 1, jpk
-             zmask(:,:,jk) = p_mask(:,:,jk) 
-         ENDDO
-      !ENDIF
-
-      IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-         IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-            je_2 = mje_crs(2)
-            DO jk = 1, jpk           
-               DO ji = nistr, niend, nn_factx
-                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                  p_fld1_crs(ii,2,jk) =  zvol(ji,je_2  ,jk) + zvol(ji+1,je_2  ,jk) + zvol(ji+2,je_2  ,jk)  &
-                     &                 + zvol(ji,je_2-1,jk) + zvol(ji+1,je_2-1,jk) + zvol(ji+2,je_2-1,jk) 
-                  !
-                  zdAm =  zvol(ji  ,je_2,jk) * zmask(ji  ,je_2,jk)  &
-                    &   + zvol(ji+1,je_2,jk) * zmask(ji+1,je_2,jk)  &
-                    &   + zvol(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) 
-                  ! 
-                  p_fld2_crs(ii,2,jk) = zdAm / p_fld1_crs(ii,2,jk) 
-               ENDDO
-            ENDDO
-         ENDIF
-      ELSE
-         je_2 = mjs_crs(2)
-         DO jk = 1, jpk           
-            DO ji = nistr, niend, nn_factx
-               ii   = ( ji - mis_crs(2) ) * rfactx_r + 2    
-               p_fld1_crs(ii,2,jk) =  zvol(ji,je_2  ,jk) + zvol(ji+1,je_2  ,jk) + zvol(ji+2,je_2  ,jk)  &
-                   &                + zvol(ji,je_2+1,jk) + zvol(ji+1,je_2+1,jk) + zvol(ji+2,je_2+1,jk)  &
-                   &                + zvol(ji,je_2+2,jk) + zvol(ji+1,je_2+2,jk) + zvol(ji+2,je_2+2,jk)  
-              !
-               zdAm = zvol(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk)  &
-                 &  + zvol(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk)  &
-                 &  + zvol(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk)  &
-                 &  + zvol(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk)  &
-                 &  + zvol(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk)  &
-                 &  + zvol(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk)  &
-                 &  + zvol(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk)  &
-                 &  + zvol(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk)  &
-                 &  + zvol(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk)
-                 ! 
-                 p_fld2_crs(ii,2,jk) = zdAm / p_fld1_crs(ii,2,jk) 
-            ENDDO
-         ENDDO
-      ENDIF
-
-      DO jk = 1, jpk           
-         DO jj  = njstr, njend, nn_facty
-            DO ji = nistr, niend, nn_factx
-               ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-               ij  = ( jj - njstr ) * rfacty_r + 3
-               !
-               p_fld1_crs(ii,ij,jk) =  zvol(ji,jj  ,jk) + zvol(ji+1,jj  ,jk) + zvol(ji+2,jj  ,jk)  &
-                   &                 + zvol(ji,jj+1,jk) + zvol(ji+1,jj+1,jk) + zvol(ji+2,jj+1,jk)  &
-                   &                 + zvol(ji,jj+2,jk) + zvol(ji+1,jj+2,jk) + zvol(ji+2,jj+2,jk) 
-               !
-               zdAm =  zvol(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk)  &
-                 &   + zvol(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk)  &
-                 &   + zvol(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk)  &
-                 &   + zvol(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk)  &
-                 &   + zvol(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk)  &
-                 &   + zvol(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk)  &
-                 &   + zvol(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk)  &
-                 &   + zvol(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk)  &
-                 &   + zvol(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk)
-                 ! 
-                p_fld2_crs(ii,ij,jk) = zdAm / p_fld1_crs(ii,ij,jk) 
+      DO jk = 1, jpk
+         DO ji = nldi_crs, nlei_crs
+
+            ijis = mis_crs(ji)
+            ijie = mie_crs(ji)
+
+            DO jj = nldj_crs, nlej_crs
+
+               ijjs = mjs_crs(jj)
+               ijje = mje_crs(jj)
+
+               p_fld1_crs(ji,jj,jk) =  SUM( zvol(ijis:ijie,ijjs:ijje,jk) )
+               zdAm                 =  SUM( zvol(ijis:ijie,ijjs:ijje,jk) * zmask(ijis:ijie,ijjs:ijje,jk) )
+               p_fld2_crs(ji,jj,jk) = zdAm / p_fld1_crs(ji,jj,jk) 
             ENDDO
          ENDDO
@@ -551,13 +421,11 @@
       REAL(wp),                                 INTENT(in)           :: psgn    ! sign 
 
-
       REAL(wp), DIMENSION(jpi_crs,jpj_crs,jpk), INTENT(out)          :: p_fld_crs ! Coarse grid box 3D quantity 
 
       !! Local variables
       INTEGER  :: ji, jj, jk 
-      INTEGER  :: ii, ij, ijie, ijje, je_2
+      INTEGER  :: ijis, ijie, ijjs, ijje
       REAL(wp) :: zflcrs, zsfcrs   
       REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk, zmask,ztabtmp
-      INTEGER  :: iji, ijj
       INTEGER  :: ir,jr
       REAL(wp), DIMENSION(nn_factx,nn_facty):: ztmp
